from dataclasses import dataclass, field
from typing import List


@dataclass
class Query:
    _from: str
    _select: str = "*"
    _where: str = ""
    _group_by: List[str] = field(default_factory=list)

    def __str__(self):

        ret = f'SELECT \"{self._select}\" '
        ret += f'FROM \"{self._from}\"'
        if self._where:
            ret += f' WHERE ({self._where}) AND $timeFilter'
        else:
            ret += ' WHERE $timeFilter'
        if self._group_by:
            group_by = ', '.join(f'"{tag}"' for tag in self._group_by)
            ret += f' GROUP BY {group_by}'
        return ret


@dataclass
class ShowTagQuery:
    base = "SHOW TAG VALUES"

    _key_name: str
    _from: str = ""

    def __str__(self):
        from_part = ""
        if self._from != "":
            from_part = f'FROM "{self._from}" '

        return f"{self.base} {from_part}WITH key = \"{self._key_name}\""
