from enum import Enum
from typing import Iterable, Tuple


class Units(str, Enum):
    seconds = 's'
    milliseconds = 'ms'
    number = 'none'


class AxisLabel(str, Enum):
    mlups = 'MLUPS per process'
    runtime = 'Runtime'


def build_alias_entry(descr, var_name) -> str:
    return f"{descr}: $tag_{var_name}"


def build_alias(alias_entries: Iterable[Tuple[str, str]]) -> str:
    return ", ".join(
        build_alias_entry(descr, var_name)
        for descr, var_name in alias_entries
    )
