from common.queries import Query, ShowTagQuery


def test_showtagquery_from():
    q = ShowTagQuery('host', 'UniformGridCPU')
    assert str(q) == 'SHOW TAG VALUES FROM \"UniformGridCPU\" WITH key = \"host\"'


def test_showtagquery_without_from():
    q = ShowTagQuery('host')
    assert str(q) == 'SHOW TAG VALUES WITH key = \"host\"'


def test_big_query():
    q = Query(
        _select='mlupsPerProcess',
        _from='UniformGridGPU',
        _where='"host" =~ /^$host$/ AND "collisionSetup" =~ /^$collisionSetup$/',
        _group_by=[
            "blocks_0",
            "blocks_1",
            "blocks_2",
            "cellsPerBlock_0",
            "cellsPerBlock_1",
            "cellsPerBlock_2",
            "gpuBlockSize_0",
            "gpuBlockSize_1",
            "gpuBlockSize_2",
            "collisionSetup",
            "stencil",
            "streamingPattern"
        ]
    )

    q1 = ('SELECT "mlupsPerProcess" '
          'FROM "UniformGridGPU" '
          'WHERE ("host" =~ /^$host$/ AND "collisionSetup" =~ /^$collisionSetup$/) AND $timeFilter '
          'GROUP BY "blocks_0", "blocks_1", "blocks_2", '
          '"cellsPerBlock_0", "cellsPerBlock_1", "cellsPerBlock_2", '
          '"gpuBlockSize_0", "gpuBlockSize_1", "gpuBlockSize_2", '
          '"collisionSetup", "stencil", "streamingPattern"')
    assert q1 == str(q)


def test_min_query():
    q = Query("UniformGridGPU")
    assert str(q) == 'SELECT "*" FROM "UniformGridGPU" WHERE $timeFilter'


def test_query_with_select():
    q = Query('UniformGridGPU', 'mlupsPerProcess')
    assert str(q) == 'SELECT "mlupsPerProcess" FROM "UniformGridGPU" WHERE $timeFilter'
