import json

from dashboards.annotations import Annotation

expected_str = r"""
{
  "datasource": "InfluxDB-1",
  "enable": true,
  "iconColor": "red",
  "name": "commit",
  "query": "SELECT \"commit\" from( SELECT first(\"mlupsPerProcess\") FROM \"PhaseFieldAllenCahn\" WHERE host =~ /^$host$/ AND $timeFilter GROUP BY \"commit\" )",
  "target": {
    "limit": 100,
    "matchAny": false,
    "tags": [],
    "type": "dashboard"
  }
}
"""


def test_annotation():
    query = "SELECT \"commit\" from( SELECT first(\"mlupsPerProcess\") FROM \"PhaseFieldAllenCahn\" WHERE host =~ /^$host$/ AND $timeFilter GROUP BY \"commit\" )"
    anno = Annotation(
        "InfluxDB-1",
        "red",
        "commit",
        query,
    )
    expected = json.loads(expected_str)

    assert expected == anno.to_json_data()
