from dashboards.panels import WrappedPanel, WrappedTimeSeries, get_arguments


def test_get_arguments_panel():
    panel = WrappedPanel("test", "InfluxDB-1")
    kwargs = get_arguments(panel)
    assert kwargs['title'] == "test"
    assert kwargs['dataSource'] == "InfluxDB-1"


def test_get_arguments_ts():
    panel = WrappedTimeSeries("test", "InfluxDB-1", unit='W')
    kwargs = get_arguments(panel)
    assert kwargs['title'] == "test"
    assert kwargs['dataSource'] == "InfluxDB-1"
    assert kwargs['unit'] == 'W'


def test_extra_kwargs():
    panel = WrappedPanel("test", "InfluxDB-1", extra_kwargs={'color': 'red'})
    kwargs = get_arguments(panel)
    assert kwargs['title'] == "test"
    assert kwargs['dataSource'] == "InfluxDB-1"
    assert kwargs['color'] == 'red'
